public class Lib_mathmp {
public static final int MAX_VALUE = 0x7fffffff;
public static final int MIN_VALUE = 0x80000001;
public static final int E = 11134;
public static final int PI = 12868;
private static final int sintab[] = {
  0, 71, 142, 214, 285, 357, 428, 499, 570, 641, 
  711, 781, 851, 921, 990, 1060, 1128, 1197, 1265, 1333, 
  1400, 1468, 1534, 1600, 1665, 1730, 1795, 1859, 1922, 1985, 
  2048, 2109, 2170, 2230, 2290, 2349, 2407, 2464, 2521, 2577, 
  2632, 2686, 2740, 2793, 2845, 2896, 2946, 2995, 3043, 3091, 
  3137, 3183, 3227, 3271, 3313, 3355, 3395, 3434, 3473, 3510, 
  3547, 3582, 3616, 3649, 3681, 3712, 3741, 3770, 3797, 3823, 
  3849, 3872, 3895, 3917, 3937, 3956, 3974, 3991, 4006, 4020, 
  4033, 4045, 4056, 4065, 4073, 4080, 4086, 4090, 4093, 4095, 
  4096};
private static final int exptab[] = {
  4096, 11134, 30266, 0x1415e, 0x36992, 0x9469c, 0x1936dc, 0x448a21,
  0xba4f54, 0x1fa7158, 0x560a774, 0xe9e2244, 0x27bc2ca9, 0x6c02d646};


private Lib_mathmp() {}


public static int fabs(int i) {  //***
// 
  if(i>0) return i;
  return -i;
}


public static int ftrunc(int i) {  //***
//    , ..   integer
  if(i<0) i -= 2048;
    else i += 2048;
  return i >> 12;
}


public static int finttoreal(int i) {  //***
// integer  fixed-real
  return i << 12;
}


public static int finttoreal2(int i, int j) {  //***
// integer  fixed-real,  i -  , j -  * 10000
  boolean flag = false;
  if (i<0) {i=-i; flag=true;}
  i=(i << 12)+(j << 12)/10000;
  if(flag) return -i;
  return i;
}


public static int fstrtoreal(String s) {  //***
//    fixed-real
  boolean flag = false;
  int len=s.length();
  int i=0;
  int c=32;
  int sum=0;
  while (i<len && c==32)  c = (byte)s.charAt(i++);
  if (c==45) {c=32; flag=true;}  //"-"
  if (c==43) c=32;               //"+"
  while (i<len && c==32)  c = (byte)s.charAt(i++);
  while (i<len && c>=48 && c<=57) {  
    sum=sum*10+c-48;
    c = (byte)s.charAt(i++);
  }
  sum <<= 12;
  while (i<len && c==32)  c = (byte)s.charAt(i++);
  if (c==46) {
    s=s+"00000";
    len=0;
    c=32;
    int sum2=0;
    while (c==32)  c = (byte)s.charAt(i++);
    while ((len++)<4 && c>=48 && c<=57) {  
      sum2=sum2*10+c-48;
      c = (byte)s.charAt(i++);
    }
    sum+=(((sum2+1) << 13)/20000);
  }
  if(flag) return -sum;
  return sum;
}  


public static String frealtostr(int i) {  //***
//fixed-real  
  boolean flag = false;
  if(i < 0) {i=-i; flag=true;}
  String s = Integer.toString(10000*(i & 0xfff) >> 12);
  while (s.length() < 4) s="0"+s;
  return (flag ? "-" : "")+Integer.toString(i >> 12)+"."+s;
}


public static int fdiv(int i, int j) {
//    fixed-real
  if(j == 0) return 0;
  if(j == 4096) return i;
  if((j & 0xfff) == 0) return i / (j >> 12);
  boolean flag = false;
  if(i < 0) {i=-i; flag=true;}
  if(j < 0) {j=-j; flag=!flag;}
  byte byte0 = 0;
  if(i > 0x64fff) {
    byte0 = 3;
    if(i > 0x3e8fff) {
      byte0 = 4;
      if(i > 0x7dffff) {
        byte0 = 6;
        if(i > 0x1f4ffff) {
          byte0 = 8;
          if(i > 0x7dfffff) byte0 = 10;
        }
      }
    }
    i += (1 << byte0);
    j += (1 << byte0);
  }
  int l = (i << (12 - byte0)) / (j >> byte0);
  return flag ? -l : l;
}


public static int fmul(int i, int j) {
//    fixed-real
  if((i & 0xfff) == 0) return j*(i >> 12);
  if((j & 0xfff) == 0) return i*(j >> 12);
  boolean flag = false;
  if(i < 0) {i=-i; flag=true;}
  if(j < 0) {j=-j; flag=!flag;}
  byte byte0 = 0;
  if(i > 0x64fff || j > 0x64fff) {
    byte0 = 2;
    if(i > 0x3e8fff || j > 0x3e8fff) {
      byte0 = 4;
      if(i > 0x271ffff || j > 0x271ffff) byte0 = 6;
    }
    i += (1 << byte0);
    j += (1 << byte0);
  }
  int l = ((i >> 12) * (j >> 12) << 12)+
          ((i & 0xfff) * (j & 0xfff) >> 12)+
          (((i & 0xfffff000) >> byte0) * ((j & 0xfff) >> byte0) >> 12 - (byte0 << 1))+
          (((i & 0xfff) >> byte0) * ((j & 0xfffff000) >> byte0) >> 12 - (byte0 << 1));
  if(l < 0) return 0;
  return flag ? -l : l;
}


public static int fsqrt2(int i, int j) {  //***
// 
  if(i <= 0) return 0;
  int k = i + 4096 >> 1;
  while ((j--)>0)  k = (k + fdiv(i, k)) >> 1;
  return k;
}


public static int fsqrt(int i) {  //***
// 
  byte byte0 = 8;
  if(i > 0x64000){
    byte0 = 12;
    if(i > 0x3e8000) byte0 = 16;
  }
  return fsqrt2(i, byte0);
}


public static int fintsqrt(int v) {
  if(v<1) return fabs(v);
  int result=0;
  int high=0;
  int low=v;
  for (int i=15; i>0; i--) {
    high = (high<<2) | ((low>>30) & 3);
    low = (low << 2); //& 0x7fffffff;
    result+=result;
    int tmp=high-(result+result+1);
    //if (high >= tmp) {
    //  high-=tmp;
    //  result++;
    //}
    if (tmp>=0) {
      high=tmp;
      result++;
    }
  }
  if (v-(result*result) >= (result-1)) return result+1;
  return result;
}


private static int sinlookup(int i, int j) {  //***
// SIN  , i -  , j - 
  if(j > 0 && j < 10 && i < 90) return sintab[i] + ((sintab[i + 1] - sintab[i]) / 10) * j;
  return sintab[i];
}


public static int fsin(int i) {  //***
// sin  i
  while(i<0) {i+=25736;}
  if(i > 25736) i %= 25736;
  int k = (i * 10) / 714;
  int j=0;
  if(i != 0 && i != 6434 && i != 12868 && i != 19302 && i != 25736)  j = (i * 100) / 714 - k * 10;
  if(k <= 90) return sinlookup(k, j);
  if(k <= 180) return sinlookup(180 - k, j);
  if(k <= 270) return -sinlookup(k - 180, j);
  return -sinlookup(360 - k, j);
}


public static int fcos(int i) {  //***
// cos  i
  return fsin(i + 6435);
}


public static int ftan(int i) {  //***
// tang  i
  return fdiv(fsin(i), fcos(i));
}


public static int fcotan(int i) {  //***
//  cotang  i
  return fdiv(4096, ftan(i));
}


public static int fasin(int i) {  //***
// arcSin  i
  boolean flag = false;
  if(i < 0) {i=-i; flag=true;}
  if(i > 4096) return 0;
  int j = 0;
  int k = sintab.length;
  for(int l = 0; l < sintab.length; l++) {
    int i1 = (i - sintab[l]);
    if (i1<0) i1=-i1;
    if(i1 < k) {
      k = i1;
      j = l;
    }
  }
  if(flag) return -(j*72);
  return j*72;
}


public static int facos(int i) {  //***
// arcCos  i
  return 6434 - fasin(i);
}


public static int fexp(int i) {  //***
//  i
  boolean flag = false;
  if(i<0) {i=-i; flag=true;}
  int l = i & 0xfff;
  i >>= 12;
  if(i > 13) return 0;
  i = exptab[i];
  if(l > 0) {
    int i1 = 0;
    int j1 = 4096;
    int k1 = 1;
    for(int l1 = 1; l1 < 7; l1++) {
      i1 += j1 / k1;
      j1 = fmul(j1, l);
      k1 *= l1;
    }
    i = fmul(i, i1);
  }
  if(flag) return fdiv(4096, i);
  return i;
}


public static int flog(int i) {  //***
//  i
  if(i <= 0) return 0;
  int l=0;
  while (i>8192) {i>>=1; l+=2839;}
  i-=4096;
  int k=i;
  for(int j = 1; j < 11 && k!=0; j++) {
    l += ((j & 1)==0 ? -k : k) / j;
    k = fmul(k, i);
  }
  return l;
}


public static int flog10(int i) {
// log10  i
  return fdiv(flog(i), flog(2));
}


private static int pii(int i, int j) {  //***
  if(i == 0) return 0;
  int k = 4096;
  while ((j--)>0)  k = fmul(k, i);
  if (k>0) return k;
  return 0;
}


public static int fpow(int i, int j) {  //***
// i   j
  boolean flag = false;
  if(j < 0) {j=-j; flag=true;}
  int k;
  if(fabs(i) < 4096 && j > 12288) {
    k = fexp(fmul(flog(i), j));
  } else {
    k = pii(i, j >> 12);
    if((j & 0xfff) != 0)  k = fmul(k, fexp(fmul(flog(i), j & 0xfff)));
  }
  if(flag) return fdiv(4096, k);
  return k;
}


public static int ftoradians(int i) {  //***
// i  
  int n1=fmul(i,12868)/180;
  int n2=fmul(i/180,12868);
  return fabs(n1)>fabs(n2) ? n1 : n2;
}


public static int ftodegrees(int i) {  //***
// i  
  int n1=fdiv(180*i,12868);
  int n2=180*fdiv(i,12868);
  return fabs(n1)>fabs(n2) ? n1 : n2;
}


public static int fatan(int i) {  //***
// arcTang
  return facos(fdiv(4096, fsqrt(fmul(i, i)+1) ));
}


public static int fatan2(int i, int j) {
// arcTang
  if(j > 0) return fatan(fdiv(i, j));
  if(j == 0) {
    if(i == 0) return 0;
    return i < 0 ? -6434 : 6434;
  }
  int k = 12868 - fatan(fabs(fdiv(i, j)));
  if(i >= 0) return k;
  return -k;
}

}
